Index: /XIOS/trunk/arch/arch-GCC_LINUX.env
===================================================================
--- /XIOS/trunk/arch/arch-GCC_LINUX.env	(revision 1447)
+++ /XIOS/trunk/arch/arch-GCC_LINUX.env	(revision 1448)
@@ -5,2 +5,4 @@
 export NETCDF_LIB_DIR=$HOME/netcdf4/lib
 
+export BOOST_INC_DIR=$HOME/boost
+export BOOST_LIB_DIR=$HOME/boost
Index: /XIOS/trunk/arch/arch-GCC_LINUX.path
===================================================================
--- /XIOS/trunk/arch/arch-GCC_LINUX.path	(revision 1447)
+++ /XIOS/trunk/arch/arch-GCC_LINUX.path	(revision 1448)
@@ -5,5 +5,5 @@
 MPI_INCDIR=""
 MPI_LIBDIR=""
-MPI_LIB=""
+MPI_LIB="-lcurl"
 
 HDF5_INCDIR="-I $HDF5_INC_DIR"
@@ -11,4 +11,8 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
 
+BOOST_INCDIR="-I $BOOST_INC_DIR"
+BOOST_LIBDIR="-L $BOOST_LIB_DIR"
+BOOST_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/trunk/arch/arch-X64_CURIE.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE.env	(revision 1447)
+++ /XIOS/trunk/arch/arch-X64_CURIE.env	(revision 1448)
@@ -1,3 +1,5 @@
 module unload netcdf
 module unload hdf5
+module unload boost
 module load netcdf/4.3.3.1_hdf5_parallel
+module load boost
Index: /XIOS/trunk/arch/arch-X64_CURIE.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE.path	(revision 1447)
+++ /XIOS/trunk/arch/arch-X64_CURIE.path	(revision 1448)
@@ -11,4 +11,8 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/trunk/arch/arch-XC30_Cray.env
===================================================================
--- /XIOS/trunk/arch/arch-XC30_Cray.env	(revision 1447)
+++ /XIOS/trunk/arch/arch-XC30_Cray.env	(revision 1448)
@@ -4,2 +4,5 @@
 export NETCDF_INC_DIR=""
 export NETCDF_LIB_DIR=""
+
+export BOOST_INC_DIR=""
+export BOOST_LIB_DIR=""
Index: /XIOS/trunk/arch/arch-XC30_Cray.path
===================================================================
--- /XIOS/trunk/arch/arch-XC30_Cray.path	(revision 1447)
+++ /XIOS/trunk/arch/arch-XC30_Cray.path	(revision 1448)
@@ -11,4 +11,8 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
 OASIS_INCDIR=""
 OASIS_LIBDIR=""
Index: /XIOS/trunk/bld.cfg
===================================================================
--- /XIOS/trunk/bld.cfg	(revision 1447)
+++ /XIOS/trunk/bld.cfg	(revision 1448)
@@ -25,5 +25,5 @@
 search_src           true
 src::zzz .
-src::date $PWD/extern/boost/src/date_time
+#src::date $PWD/extern/boost/src/date_time
 src::blitz $PWD/extern/blitz/src
 src::netcdf $PWD/extern/netcdf4
Index: /XIOS/trunk/make_xios
===================================================================
--- /XIOS/trunk/make_xios	(revision 1447)
+++ /XIOS/trunk/make_xios	(revision 1448)
@@ -5,12 +5,10 @@
 use_oasis="false"
 oasis="oasis3_mct"
+use_extern_boost="false"
 use_memtrack="false"
 job="1"
 netcdf_lib="netcdf4_par"
 compil_mode="prod"
-arch_path="arch"
-arch_default_path="arch"
-arch_defined="FALSE"
-arch_path_defined="FALSE"
+
 
 # Traitement de la ligne de commande
@@ -29,4 +27,5 @@
 	    echo "       [--full] : to generate dependencies and recompile from scratch"
 	    echo "       [--use_oasis 'oasis3' 'oasis3_mct' : default oasis3_mct] : to use Oasis coupler"
+        echo "       [--use_extern_boost : to use external boost library"
 	    echo "       [--doc] : to generate Doxygen documentation (not available yet)"
 	    echo "       [--job ntasks] : to use parallel compilation with ntasks"
@@ -39,13 +38,13 @@
          "--dev")   compil_mode="dev"   ; shift ;;
          "--debug") compil_mode="debug" ; shift ;;
-         "--arch")  arch=$2     ; arch_defined="TRUE"; shift ; shift ;;
-         "--arch_path")  arch_path=$2     ; arch_path_defined="TRUE"; shift ; shift ;;
+         "--arch")  arch=$2     ; shift ; shift ;;
          "--avail") ls arch/*.fcm | cut -d"-" -f2 | cut -d"." -f1 ; exit ;; 
          "--full")  compil_full="true"  ; shift ;;
          "--use_oasis")  use_oasis="true" oasis=$2 ; shift ; shift  ;;
+         "--use_extern_boost")  use_extern_boost="true" ; shift  ;;
          "--doc")   doc="true"          ; shift ;;
          "--job")   job=$2              ; shift ; shift ;;
          "--netcdf_lib")   netcdf_lib=$2 ; shift ; shift ;;
-         "--memtrack")  use_memtrack="true" memtrack=$2  ; shift ; shift ;;
+         "--memtrack")   use_memtrack="true" ; shift ;;
          *)         code="$1"           ; shift ;;
       esac
@@ -75,38 +74,22 @@
 mkdir .void_dir
 
-if [[ "$arch_defined" == "TRUE" ]]
-then
-  rm -f arch.path
-  rm -f arch.fcm
-  rm -f arch.env
-
-  if test -f $arch_path/arch-${arch}.path
-  then
-    ln -s $arch_path/arch-${arch}.path arch.path
-  elif test -f $arch_default_path/arch-${arch}.path
-  then
-    ln -s $arch_default_path/arch-${arch}.path arch.path
-  fi
-        
-  if test -f $arch_path/arch-${arch}.fcm
-  then
-    ln -s $arch_path/arch-${arch}.fcm arch.fcm
-  elif test -f $arch_default_path/arch-${arch}.fcm
-  then
-    ln -s $arch_default_path/arch-${arch}.fcm arch.fcm
-  fi
-
-  if test -f $arch_path/arch-${arch}.env
-  then
-    ln -s $arch_path/arch-${arch}.env arch.env
-  elif test -f $arch_default_path/arch-${arch}.env
-  then
-    ln -s $arch_default_path/arch-${arch}.env arch.env
+if [[ !(-z $arch) ]]
+   then
+      rm -f  $install_dir/arch.path
+      rm -f  $install_dir/arch.fcm
+      rm -f  $install_dir/arch.env
+      ln -s  $install_dir/arch/arch-${arch}.path $install_dir/arch.path
+      ln -s  $install_dir/arch/arch-${arch}.fcm  $install_dir/arch.fcm
+
+      if test -f $install_dir/arch/arch-${arch}.env
+      then
+        ln -s $install_dir/arch/arch-${arch}.env arch.env
+      else
+        ln -s $install_dir/.void_file arch.env
+      fi
+
+      source $install_dir/arch.env
+      source $install_dir/arch.path
   else
-    ln -s .void_file arch.env
-  fi
-  source arch.env
-  source arch.path
-else
       echo "Please choose a target achitecture --> list all available architecture using make_xios --avail!"
       exit 1
@@ -168,25 +151,26 @@
     XIOS_FINCDIR="$OASIS_INCDIR $XIOS_FINCDIR"
     XIOS_LIB="$OASIS_LIBDIR $OASIS_LIB $XIOS_LIB"
+fi
+
+# Setting path for boost
+if [[ "$use_extern_boost" == "true" ]]
+then
+   ln -s $PWD/.void_dir $PWD/extern/boost
+else
+   ln -s $PWD/extern/boost $PWD/extern/boost
+   export BOOST_INCDIR="-I${PWD}/extern/boost"
+   export BOOST_LIBDIR=""
+   export BOOST_LIB=""
+fi
+
+
+if [[ "$use_memtrack" == "true" ]]
+   then
+   XIOS_LIB="$ADDR2LINE_LIBDIR $ADDR2LINE_LIB $XIOS_LIB"
+   XIOS_CPPKEY="$XIOS_CPPKEY XIOS_MEMTRACK"
 fi 
 
-if [[ "$use_memtrack" == "true" ]]
-   then
-   XIOS_CPPKEY="$XIOS_CPPKEY XIOS_MEMTRACK"
-
-    if [[ "$memtrack" == "light" ]]
-    then
-	XIOS_CPPKEY="$XIOS_CPPKEY XIOS_MEMTRACK_LIGHT"
-    elif [[ "$memtrack" == "FULL"  ]]
-    then
-      XIOS_LIB="$ADDR2LINE_LIBDIR $ADDR2LINE_LIB $XIOS_LIB"
-      XIOS_CPPKEY="$XIOS_CPPKEY XIOS_MEMTRACK_FULL"
-    else
-	echo "Bad choice for --memtrack argument : choose between 'light','full'"
-	exit
-    fi
-fi 
-
-XIOS_CINCDIR="$NETCDF_INCDIR $HDF5_INCDIR $MPI_INCDIR"
-XIOS_FINCDIR="$NETCDF_INCDIR $XIOS_FINCDIR $MPI_INCDIR"
+XIOS_CINCDIR="$NETCDF_INCDIR $HDF5_INCDIR $MPI_INCDIR $BOOST_INCDIR"
+XIOS_FINCDIR="$NETCDF_INCDIR $XIOS_FINCDIR $MPI_INCDIR $BOOST_INCDIR"
 
 XIOS_LIB="$XIOS_LIB $NETCDF_LIBDIR $HDF5_LIBDIR $MPI_LIBDIR $NETCDF_LIB $HDF5_LIB $MPI_LIB"