Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.env
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.env	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.env	(revision 1449)
@@ -5,2 +5,6 @@
 export NETCDF_LIB_DIR=$HOME/netcdf4/lib
 
+export BOOST_INC_DIR=$HOME/boost
+export BOOST_LIB_DIR=$HOME/boost
+
+
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.path
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.path	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-GCC_LINUX.path	(revision 1449)
@@ -11,4 +11,8 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
 
+BOOST_INCDIR="-I $BOOST_INC_DIR"
+BOOST_LIBDIR="-L $BOOST_LIB_DIR"
+BOOST_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.env
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.env	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.env	(revision 1449)
@@ -1,3 +1,5 @@
 module unload netcdf
 module unload hdf5
+module unload boost
 module load netcdf/4.3.3.1_hdf5_parallel
+module load boost
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.path
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.path	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-X64_CURIE.path	(revision 1449)
@@ -11,4 +11,8 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
 OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.env
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.env	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.env	(revision 1449)
@@ -4,2 +4,5 @@
 export NETCDF_INC_DIR=""
 export NETCDF_LIB_DIR=""
+
+export BOOST_INC_DIR=""
+export BOOST_LIB_DIR=""
Index: /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.path
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.path	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/arch/arch-XC30_Cray.path	(revision 1449)
@@ -11,4 +11,8 @@
 HDF5_LIB=""
 
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
 OASIS_INCDIR=""
 OASIS_LIBDIR=""
Index: /XIOS/dev/XIOS_DEV_CMIP6/bld.cfg
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/bld.cfg	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/bld.cfg	(revision 1449)
@@ -25,5 +25,5 @@
 search_src           true
 src::zzz .
-src::date $PWD/extern/boost/src/date_time
+#src::date $PWD/extern/boost/src/date_time
 src::blitz $PWD/extern/blitz/src
 src::netcdf $PWD/extern/netcdf4
Index: /XIOS/dev/XIOS_DEV_CMIP6/make_xios
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/make_xios	(revision 1448)
+++ /XIOS/dev/XIOS_DEV_CMIP6/make_xios	(revision 1449)
@@ -5,8 +5,10 @@
 use_oasis="false"
 oasis="oasis3_mct"
+use_extern_boost="false"
 use_memtrack="false"
 job="1"
 netcdf_lib="netcdf4_par"
 compil_mode="prod"
+
 
 # Traitement de la ligne de commande
@@ -25,4 +27,5 @@
 	    echo "       [--full] : to generate dependencies and recompile from scratch"
 	    echo "       [--use_oasis 'oasis3' 'oasis3_mct' : default oasis3_mct] : to use Oasis coupler"
+        echo "       [--use_extern_boost : to use external boost library"
 	    echo "       [--doc] : to generate Doxygen documentation (not available yet)"
 	    echo "       [--job ntasks] : to use parallel compilation with ntasks"
@@ -39,4 +42,5 @@
          "--full")  compil_full="true"  ; shift ;;
          "--use_oasis")  use_oasis="true" oasis=$2 ; shift ; shift  ;;
+         "--use_extern_boost")  use_extern_boost="true" ; shift  ;;
          "--doc")   doc="true"          ; shift ;;
          "--job")   job=$2              ; shift ; shift ;;
@@ -147,5 +151,17 @@
     XIOS_FINCDIR="$OASIS_INCDIR $XIOS_FINCDIR"
     XIOS_LIB="$OASIS_LIBDIR $OASIS_LIB $XIOS_LIB"
-fi 
+fi
+
+# Setting path for boost
+if [[ "$use_extern_boost" == "true" ]]
+then
+   ln -s $PWD/.void_dir $PWD/extern/boost
+else
+   ln -s $PWD/extern/boost $PWD/extern/boost
+   export BOOST_INCDIR="-I${PWD}/extern/boost"
+   export BOOST_LIBDIR=""
+   export BOOST_LIB=""
+fi
+
 
 if [[ "$use_memtrack" == "true" ]]
@@ -155,6 +171,6 @@
 fi 
 
-XIOS_CINCDIR="$NETCDF_INCDIR $HDF5_INCDIR $MPI_INCDIR"
-XIOS_FINCDIR="$NETCDF_INCDIR $XIOS_FINCDIR $MPI_INCDIR"
+XIOS_CINCDIR="$NETCDF_INCDIR $HDF5_INCDIR $MPI_INCDIR $BOOST_INCDIR"
+XIOS_FINCDIR="$NETCDF_INCDIR $XIOS_FINCDIR $MPI_INCDIR $BOOST_INCDIR"
 
 XIOS_LIB="$XIOS_LIB $NETCDF_LIBDIR $HDF5_LIBDIR $MPI_LIBDIR $NETCDF_LIB $HDF5_LIB $MPI_LIB"