Index: /XIOS/trunk/src/context_client.cpp
===================================================================
--- /XIOS/trunk/src/context_client.cpp	(revision 1470)
+++ /XIOS/trunk/src/context_client.cpp	(revision 1471)
@@ -290,5 +290,5 @@
      for (std::map<int,StdSize>::const_iterator it = mapSize.begin(), ite = mapSize.end(); it != ite; ++it)
      {
-       double ratio = double(it->second) / maxEventSize.at(it->first);
+       double ratio = double(it->second) / maxEventSizes[it->first];
        if (ratio < minBufferSizeEventSizeRatio) minBufferSizeEventSizeRatio = ratio;
      }
Index: /XIOS/trunk/src/filter/file_writer_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/file_writer_filter.cpp	(revision 1470)
+++ /XIOS/trunk/src/filter/file_writer_filter.cpp	(revision 1471)
@@ -29,5 +29,5 @@
       for (size_t idx = 0; idx < nbData; ++idx)
       {
-        if (NumTraits<double>::isnan(dataArray(idx)))
+        if (NumTraits<double>::isNan(dataArray(idx)))
           dataArray(idx) = missingValue;
       }
Index: /XIOS/trunk/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1470)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1471)
@@ -119,5 +119,5 @@
     bool ignoreMissingValue = false; 
     double defaultValue = std::numeric_limits<double>::quiet_NaN();
-    if (0 != dataDest.numElements()) ignoreMissingValue = NumTraits<double>::isnan(dataDest(0));
+    if (0 != dataDest.numElements()) ignoreMissingValue = NumTraits<double>::isNan(dataDest(0));
 
     const std::list<CGridTransformation::SendingIndexGridSourceMap>& listLocalIndexSend = gridTransformation->getLocalIndexToSendFromGridSource();
Index: /XIOS/trunk/src/filter/store_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/store_filter.cpp	(revision 1470)
+++ /XIOS/trunk/src/filter/store_filter.cpp	(revision 1471)
@@ -93,5 +93,5 @@
       for (size_t idx = 0; idx < nbData; ++idx)
       {
-        if (NumTraits<double>::isnan(packet->data(idx)))
+        if (NumTraits<double>::isNan(packet->data(idx)))
           packet->data(idx) = missingValue;
       }
Index: /XIOS/trunk/src/functor/accumulate.cpp
===================================================================
--- /XIOS/trunk/src/functor/accumulate.cpp	(revision 1470)
+++ /XIOS/trunk/src/functor/accumulate.cpp	(revision 1471)
@@ -34,7 +34,7 @@
             double* out=_doutput.dataFirst();
             for (i=0; i<n; ++i,++in,++out) 
-              if (!NumTraits<double>::isnan(*in))
+              if (!NumTraits<double>::isNan(*in))
               {
-                if(!NumTraits<double>::isnan(*out)) *out  += *in;
+                if(!NumTraits<double>::isNan(*out)) *out  += *in;
                 else *out=*in ;
               }
Index: /XIOS/trunk/src/functor/average.cpp
===================================================================
--- /XIOS/trunk/src/functor/average.cpp	(revision 1470)
+++ /XIOS/trunk/src/functor/average.cpp	(revision 1471)
@@ -43,5 +43,5 @@
             int* nc=nbcalls.dataFirst() ;
             for (i=0; i<n; ++i,++nc,++in) 
-              if (!NumTraits<double>::isnan(*in)) (*nc) ++;
+              if (!NumTraits<double>::isNan(*in)) (*nc) ++;
           }
         }
@@ -55,5 +55,5 @@
             int* nc=nbcalls.dataFirst() ;
             for (i=0; i<n; ++i,++in,++out,++nc) 
-              if (!NumTraits<double>::isnan(*in)) 
+              if (!NumTraits<double>::isNan(*in)) 
               {
                 if (*nc != 0) (*out)  += *in;
Index: /XIOS/trunk/src/functor/maximum.cpp
===================================================================
--- /XIOS/trunk/src/functor/maximum.cpp	(revision 1470)
+++ /XIOS/trunk/src/functor/maximum.cpp	(revision 1471)
@@ -34,7 +34,7 @@
            { 
              for (; it1 != end1; it1++, it++) 
-               if (!NumTraits<double>::isnan(*it1))
+               if (!NumTraits<double>::isNan(*it1))
                {
-                 if (!NumTraits<double>::isnan(*it)) *it = std::max(*it1, *it);
+                 if (!NumTraits<double>::isNan(*it)) *it = std::max(*it1, *it);
                  else *it=*it1 ;  
                }
Index: /XIOS/trunk/src/functor/minimum.cpp
===================================================================
--- /XIOS/trunk/src/functor/minimum.cpp	(revision 1470)
+++ /XIOS/trunk/src/functor/minimum.cpp	(revision 1471)
@@ -36,7 +36,7 @@
           { 
             for (; it1 != end1; it1++, it++) 
-              if (!NumTraits<double>::isnan(*it1))
+              if (!NumTraits<double>::isNan(*it1))
               {
-                if (!NumTraits<double>::isnan(*it)) *it = std::min(*it1, *it);
+                if (!NumTraits<double>::isNan(*it)) *it = std::min(*it1, *it);
                 else *it=*it1 ;
               }
Index: /XIOS/trunk/src/transformation/Functions/average_reduction.cpp
===================================================================
--- /XIOS/trunk/src/transformation/Functions/average_reduction.cpp	(revision 1470)
+++ /XIOS/trunk/src/transformation/Functions/average_reduction.cpp	(revision 1471)
@@ -47,5 +47,5 @@
       currentlocalIndex = localIndex[idx].first;
       currentWeight     = localIndex[idx].second;
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      if (!NumTraits<double>::isNan(*(dataInput + idx)))
       {
         if (flagInitial[currentlocalIndex])
Index: /XIOS/trunk/src/transformation/Functions/max_reduction.cpp
===================================================================
--- /XIOS/trunk/src/transformation/Functions/max_reduction.cpp	(revision 1470)
+++ /XIOS/trunk/src/transformation/Functions/max_reduction.cpp	(revision 1471)
@@ -41,5 +41,5 @@
     {
       currentlocalIndex = localIndex[idx].first;      
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      if (!NumTraits<double>::isNan(*(dataInput + idx)))
       {
         if (flagInitial[currentlocalIndex])
Index: /XIOS/trunk/src/transformation/Functions/min_reduction.cpp
===================================================================
--- /XIOS/trunk/src/transformation/Functions/min_reduction.cpp	(revision 1470)
+++ /XIOS/trunk/src/transformation/Functions/min_reduction.cpp	(revision 1471)
@@ -41,5 +41,5 @@
     {
       currentlocalIndex = localIndex[idx].first;
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      if (!NumTraits<double>::isNan(*(dataInput + idx)))
       {
         if (flagInitial[currentlocalIndex])
Index: /XIOS/trunk/src/transformation/Functions/sum_reduction.cpp
===================================================================
--- /XIOS/trunk/src/transformation/Functions/sum_reduction.cpp	(revision 1470)
+++ /XIOS/trunk/src/transformation/Functions/sum_reduction.cpp	(revision 1471)
@@ -43,5 +43,5 @@
     {
       currentlocalIndex = localIndex[idx].first;   
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
+      if (!NumTraits<double>::isNan(*(dataInput + idx)))
       {   
         if (flagInitial[currentlocalIndex])
Index: /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 1470)
+++ /XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 1471)
@@ -38,5 +38,5 @@
     for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      if (NumTraits<double>::isnan(*(dataInput + idx)))
+      if (NumTraits<double>::isNan(*(dataInput + idx)))
       {
         flagInitial[localIndex[idx].first] = false;
Index: /XIOS/trunk/src/utils.hpp
===================================================================
--- /XIOS/trunk/src/utils.hpp	(revision 1470)
+++ /XIOS/trunk/src/utils.hpp	(revision 1471)
@@ -257,5 +257,5 @@
     return 1e-12;
   }
-  static inline bool isnan(const Scalar& v) {
+  static inline bool isNan(const Scalar& v) {
     return (v != v);
   }